import 'dart:math';

import 'package:admob_flutter/admob_flutter.dart';
import 'package:flutter/material.dart';
import 'package:get/get_rx/src/rx_types/rx_types.dart';
import 'package:unity_ads_plugin/unity_ads_plugin.dart';

late AdmobInterstitial interstitialAd;
late AdmobReward rewardAd;

var GoogleIntraUnitId = "/6499/example/interstitial";
var GoogleBannerUnitId = "/6499/example/banner";
var GoogleReawaredUnitId = "/6499/example/rewarded";
var UnityIntraUnitId = "Video_Android";
var UnityBannerUnitId = "Banner_Android";
var UnityProjectId = "4125684";

class Googleads {
  static RxBool googleads = false.obs;
  static RxBool unityads = false.obs;
  static RxBool webview = false.obs;

  static logic() {
    var rng = Random();
    for (var i = 0; i < 1; i++) {
      int number = rng.nextInt(200);

      if (number < 150) {
        googleads = true.obs;
      } else if (number > 151 && number < 170) {
        unityads = true.obs;
      } else if (number >= 171 && number <= 200) {
        webview = true.obs;
      }
    }
  }

  static ini() {
    WidgetsFlutterBinding.ensureInitialized();
    // Initialize without device test ids.
    Admob.initialize();
  }

  static loadIntra() {
    interstitialAd = AdmobInterstitial(
      adUnitId: GoogleIntraUnitId,
    );
    interstitialAd.load();
  }

  static var BannerAdsShow = AdmobBanner(
    adUnitId: GoogleBannerUnitId,
    adSize: AdmobBannerSize.BANNER,
  );

  static loadReward() {
    rewardAd = AdmobReward(
      adUnitId: GoogleReawaredUnitId,
    );
    rewardAd.load();
  }
}

class Unityads {
  static unityIntraLoad() {
    UnityAds.load(
      placementId: UnityIntraUnitId,
      onComplete: (placementId) => print('Load Complete $placementId'),
      onFailed: (placementId, error, message) =>
          print('Load Failed $placementId: $error $message'),
    );
  }

  static var unityBannerShow = UnityBannerAd(
    placementId: UnityBannerUnitId,
    onLoad: (placementId) => print('Banner loaded: $placementId'),
    onClick: (placementId) => print('Banner clicked: $placementId'),
    onFailed: (placementId, error, message) =>
        print('Banner Ad $placementId failed: $error $message'),
  );

  static iniUnit() {
    UnityAds.init(
      testMode: true,
      gameId: UnityProjectId,
    );
  }
}
